/********************************** (C) COPYRIGHT *******************************
* File Name          : MAIN.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/01/22
* Description        : CH569HSPIʵ˫ͨ
* ˵
*                      (1)2CH569ֱΪHOSTSLAVERеͨв;
*                           1K,ͻΪ48;
*                           ʵٶ: Լ400Mֽ/S; 48M/0.12046 = 398M;
*
*                      (2)2CH569ֱΪHOSTSLAVER˫ͨв;
*                           HOSTSLAVER1,SLAVERHOSTظ1С;
*                           1K,ͻΪ48;
*                           ʵٶ: Լ389Mֽ/S; 48M/0.12343 = 389M;
*                           ϰӼж,ʵٶ: Լ340Mֽ/S;
*
*                      (3)ͨ޸DEF_HSPI_MODEлHOSTSLAVERģʽ;
*                           ͨ޸DEF_HSPI_DOUBLE_DIR_ENΪ01лԻ˫;
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "MAIN.h"                                                               /* ͷļ */

/******************************************************************************/
/*  */
UINT8V  USB_WorkMode = DEF_MODE_BULK;                                           /* USBģʽ: 0: ģʽ; 1: UVCͬģʽ; */

UINT32V Dbg_Idle_TimeCount = 0x00;
UINT64V Dbg_HSPI_Tx_TLen = 0x00;
UINT64V Dbg_HSPI_Rx_TLen = 0x00;

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void )
{
    UINT32 i,j;

    /*****************************ϵͳسʼ*******************************/
    SystemInit( FREQ_SYS );
	Delay_Init( FREQ_SYS );

    /*****************************ģųʼ**************************/
	UART1_Init( DEF_UART1_BAUDRATE );
	//HSPI_GPIO_Init( );     //Ϊ                        /* HSPIӿGPIOʼ */



    /* HTCLK(PA11)HTREQ(PA9)HTVLD(PA21)HTACK(PA10)Ϊ,Ϊ16mA */
    R32_PA_DIR |= ( ( 1 << 9 ) | ( 1 << 10 ) | ( 1 << 11 ) | ( 1 << 21 ) );
    R32_PA_DRV |= ( ( 1 << 11 ) );
    R32_PA_PU &= ~( ( 1 << 9 ) | ( 1 << 10 ) | ( 1 << 11 ) | ( 1 << 21 ) );
    R32_PA_PD &= ~( ( 1 << 9 ) | ( 1 << 10 ) | ( 1 << 11 ) | ( 1 << 21 ) );

    /* HTRDY(PA23)HRCLK(PA19)HRACK(PA18)HRVLD(PA6)Ϊ */
    R32_PA_DIR &= ~( ( 1 << 6 ) | ( 1 << 18 ) | ( 1 << 19 ) | ( 1 << 23 ) );
    R32_PA_PU &= ~( ( 1 << 6 ) | ( 1 << 18 ) | ( 1 << 19 ) | ( 1 << 23 ) );
    R32_PA_PD |= ( ( 1 << 6 ) | ( 1 << 18 ) | ( 1 << 19 ) | ( 1 << 23 ) );

    /*  HD0(PA6) HD1(PA4) HD2(PA22) HD3(PA3)  HD4(PA2)  HD5(PA1)  HD6(PA0)  HD7(PB21)
           HD8(PB20) HD9(PB19)HD10(PB18)HD11(PB17)HD12(PA17)HD13(PB16)HD14(PB15)HD15(PB14)
           HD16(PB0) HD17(PB1)HD18(PB2) HD19(PA20)HD20(PB3) HD21(PB4) HD22(PB5) HD23(PB6)
           HD24(PA16)HD25(PB7)HD26(PB8) HD27(PB9) HD28(PB10)HD29(PB11)HD30(PB12)HD31(PB13)Ϊ */
    R32_PA_DIR &= ~( ( 1 << 6 ) | ( 1 << 4 ) | ( 1 << 22 ) | ( 1 << 3 ) | ( 1 << 2 ) | ( 1 << 1 ) | ( 1 << 0 ) |
                     ( 1 << 17 ) | ( 1 << 20 ) | ( 1 << 16 ) );
    R32_PA_PU &= ~( ( 1 << 6 ) | ( 1 << 4 ) | ( 1 << 22 ) | ( 1 << 3 ) | ( 1 << 2 ) | ( 1 << 1 ) | ( 1 << 0 ) |
                    ( 1 << 17 ) | ( 1 << 20 ) | ( 1 << 16 ) );
    R32_PA_PD &= ~( ( 1 << 6 ) | ( 1 << 4 ) | ( 1 << 22 ) | ( 1 << 3 ) | ( 1 << 2 ) | ( 1 << 1 ) | ( 1 << 0 ) |
                    ( 1 << 17 ) | ( 1 << 20 ) | ( 1 << 16 ) );

    R32_PB_DIR &= 0xFFC00000;
    R32_PB_PU &= 0xFFC00000;
    R32_PB_PD &= 0xFFC00000;



    GPIO_Init( );                                                               /* ӲGPIOʼ */
	DUG_PRINTF("CH56x HSPI Test@120MHZ_V1.%d\n",(UINT16)DEF_PROG_VERSION - 0x01 );
    DUG_PRINTF("Edit Date and Time is: "__DATE__"  " __TIME__"\n");
    DUG_PRINTF("USB_WorkMode: %x\n",(UINT16)USB_WorkMode);

    /*****************************ʱسʼ **************************/
    Timer1_Init( 240000 );                                                      /* ʱ1ʼ(ʱ2mS) */

    /*******************************************************************/
    DUG_PRINTF("Main\n");

    /*****************************HSPI*************************************/
    /* PB24Ϊ,Ϊ16mA */
    R32_PB_DIR |= ( ( 1 << 24 ) );
    R32_PB_DRV |= ( ( 1 << 24 ) );
    R32_PB_PU &= ~( ( 1 << 24 ) );
    R32_PB_PD &= ~( ( 1 << 24 ) );

    Dbg_Idle_TimeCount = 0x00;
    Dbg_HSPI_Tx_TLen = 0x00;
    Dbg_HSPI_Rx_TLen = 0x00;
    Delay_mS( 1000 );

    /* ݲͬģʽвͬ */
    BULKMode_HSPI_Test( );
	while( 1 );
}
